package com.weaver.seconddev.cpic.controller;

import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.cpic.constant.Constants;
import com.weaver.seconddev.cpic.dao.EmployeeExportTxtDao;
import com.weaver.seconddev.cpic.service.EmployeeExportTxtService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/api/secondev/cpic/employeeexp")
public class EmployeeExportTxtController {

    private final Logger log = LoggerFactory.getLogger(EmployeeExportTxtController.class);

    @Autowired
    EmployeeExportTxtService employeeExportTxtService;

    @Autowired
    private EmployeeExportTxtDao employeeExportTxtDao;


    @GetMapping("/expTxt")
    @ResponseBody
    public ResponseEntity<byte[]> expTxt(HttpServletResponse response) {
        log.error("expTxt");
        String s="11111|1|21321|02|0213|0123456|测试岗位|101|测试公司|TB00001|测试部门|1900-01-01|1900-01-01|N|1900-01-01|1900-01-01|01|T3|10|科技序列|测试职衔|1900-01-01";
        byte[] bytes = s.getBytes();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String currentDate = sdf.format(new Date());
        String times = "01";
        String filename = "EHR_TO_IMAM_JOB_"+currentDate+times+".txt";
        log.error("filename:"+filename);
        return ResponseEntity.ok().contentType(MediaType.APPLICATION_OCTET_STREAM)
                .header(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + filename + "\"")
                .body(bytes);
    }


    @RequestMapping("/expTxt2")
    @WeaPermission(publicPermission = true)
    @ResponseBody
    public ResponseEntity<byte[]> expTxt2(HttpServletResponse response) {
        log.error("download88");
        String s="11111|1|21321|02|0213|0123456|测试岗位|101|测试公司|TB00001|测试部门|1900-01-01|1900-01-01|N|1900-01-01|1900-01-01|01|T3|10|科技序列|测试职衔|1900-01-01";
        byte[] bytes = s.getBytes();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String currentDate = sdf.format(new Date());
        String times = "01";
        String filename = "EHR_TO_IMAM_JOB_"+currentDate+times+".txt";
        log.error("filename:"+filename);
        return ResponseEntity.ok().contentType(MediaType.APPLICATION_OCTET_STREAM)
                .header(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + filename + "\"")
                .body(bytes);
    }

    @WeaPermission(publicPermission = true)
    @GetMapping("/getEmployeeBase")
    public WeaResult<Object> getEmployeeBase(HttpServletRequest request,HttpServletResponse response) {
        log.error("getEmployeeBase");
        List<Map<String, Object>> baseList = employeeExportTxtService.queryEmployeeBase(Constants.TENANT_KEY);
        Map<String, Object> recordMap = new HashMap<String,Object>();
        recordMap.put("list",baseList);
        return WeaResult.success(recordMap);
    }

    @WeaPermission(publicPermission = true)
    @GetMapping("/getEmployeeCustom")
    public WeaResult<Object> getEmployeeCustom(HttpServletRequest request,HttpServletResponse response) {
        log.error("getEmployeeCustom");
        List<Map<String, Object>> customList = employeeExportTxtService.queryEmployeeCustom(Constants.TENANT_KEY);
        Map<String, Object> recordMap = new HashMap<String,Object>();
        recordMap.put("list",customList);
        return WeaResult.success(recordMap);
    }

    @WeaPermission(publicPermission = true)
    @GetMapping("/expTxt3")
    public ResponseEntity<byte[]> expTxt3(HttpServletRequest request,HttpServletResponse response) {
        log.error("getEmployeeBase");
        String type = request.getParameter("type");
        String employeeExpTxt = employeeExportTxtService.queryEmployeeExpTxt(Constants.TENANT_KEY,type);

        byte[] bytes = employeeExpTxt.getBytes();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String currentDate = sdf.format(new Date());

        String times = employeeExportTxtDao.queryExportTxtTimesByDay(Constants.TENANT_KEY);
        if(StringUtils.isBlank(times)){
            times = "01";
        }
        String filename = "EHR_TO_IMAM_JOB_"+currentDate+times+".txt";
        log.error("filename:"+filename);
        return ResponseEntity.ok().contentType(MediaType.APPLICATION_OCTET_STREAM)
                .header(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + filename + "\"")
                .body(bytes);

    }




}
