package com.weaver.seconddev.cpic.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.weaver.seconddev.cpic.constant.Constants;
import com.weaver.seconddev.cpic.dao.EmployeeImportTxtDao;
import com.weaver.seconddev.cpic.service.EmployeeImportTxtService;
import okhttp3.*;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/***
 * author:shil
 */
@Service
public class EmployeeImportTxtServiceImpl implements EmployeeImportTxtService {

    private final static Logger log = LoggerFactory.getLogger(EmployeeImportTxtServiceImpl.class);
    @Autowired
    private EmployeeImportTxtDao employeeImportTxtDao;

    @Override
    public Map<String,String>  syncEmployeeData(String action,String userName,String departmentId,String idNo,
                                   String birthday,String positionId,String maritalStatus,String nation,
                                   String personnelStatus,
                                   String account,String firstWorkDate,
                                   String mobile,String sex,String hiredate,String id_no,
                                   String native_place,String household_type,String politics_status,
                                   String job_num,String graduate_date,String graduate_school,String degree,String education,
                                   String mardate,String zjlx,String major,
                                   String jkzk,String wbxtgh) {


        Map<String,String> returnMap = new HashMap<String,String>();
        boolean effect = false;
        String employeeid = "";
        Map<String,Object> employeeMap = employeeImportTxtDao.queryEmployeeByNationalId(Constants.TENANT_KEY,idNo);
        log.error("employeeMap:"+employeeMap.size());
        if("HIR".equals(action)){
            if(employeeMap.size() > 0){
                if(employeeMap.containsKey("id")){
                    employeeid = String.valueOf(employeeMap.get("id"));
                    if(StringUtils.isBlank(employeeid)){
                        effect = true;
                    }
                }else{
                    effect = true;
                }
            }else{
                effect = true;
            }
        }else if("XFR".equals(action)){
            if(employeeMap.containsKey("id")){
                employeeid = String.valueOf(employeeMap.get("id"));
                if(StringUtils.isNotBlank(employeeid)){

                    effect = true;
                }
            }
        }
        log.error("effect:"+effect);

        if(effect){

            JSONArray paramArray = new JSONArray();
            JSONObject paramJson = new JSONObject();
            /***
             * 新增必填；可以是部门，也可以是分部；与【数据规则-组织规则】相关；例如：规则是编号，内容提供编号
             */
            paramJson.put("department",departmentId);
            /***
             * 新增必填
             */
            paramJson.put("position",positionId);

            paramJson.put("username",userName);

            paramJson.put("mobile",mobile);
            paramJson.put("sex",sex);

            paramJson.put("job_num",job_num);

            paramJson.put("hiredate",hiredate);

            /***
             * 身份证
             */
            paramJson.put("id_no",id_no);

            paramJson.put("birthday",birthday);

            paramJson.put("graduate_date",graduate_date);
            paramJson.put("graduate_school",graduate_school);
            paramJson.put("degree",degree);
            paramJson.put("education",education);

            /***
             * 1:试用；2:试用延期；3:正式；4:临时;5:实习;6:离职;7:退休
             */
            paramJson.put("personnel_status",personnelStatus);

//        paramJson.put("job_call","");
            /**
             * 婚姻状况  married:已婚,unmarried:未婚,divorced:离异
             */
            paramJson.put("marital_status",maritalStatus);

            paramJson.put("native_place",native_place);
            /***
             * 民族
             */
            paramJson.put("nation",nation);
            /**
             * 户口类型
             */
            paramJson.put("household_type",household_type);
            /**
             *  政治面貌
             *
             */
            paramJson.put("politics_status",politics_status);

            /**
             * 首次参加工作日期
             */
            paramJson.put("first_work_date",firstWorkDate);
            paramJson.put("sec_level","20");
            paramJson.put("accounttype","0");

            String extendFormTable = "ft_1085594606753972224";
            String dataKey = "'zy','kssj','jssj','zjlx','jkzk','hysxrq'";
            Map<String,Object> userInfoMap = employeeImportTxtDao.queryFromTableField(Constants.TENANT_KEY,extendFormTable,dataKey);
            JSONObject userInfoExtend = new JSONObject();
            log.error("major:"+major);
            if(userInfoMap.containsKey("zy")){
                String zyFieldId = String.valueOf(userInfoMap.get("zy")) ;
                log.error("zyFieldId:"+zyFieldId);
                userInfoExtend.put(zyFieldId,major);
            }
            log.error("graduate_date:"+graduate_date);
            if(graduate_date.length() > 10){
                graduate_date = graduate_date.substring(0,10);
            }
            log.error("graduate_date2:"+graduate_date);
            if(userInfoMap.containsKey("jssj")){
                String jssjFieldId = String.valueOf(userInfoMap.get("jssj")) ;
                log.error("jssjFieldId:"+jssjFieldId);
                userInfoExtend.put(jssjFieldId,graduate_date);
            }

            log.error("zjlx:"+zjlx);
            if(userInfoMap.containsKey("zjlx")){
                String zjlxFieldId = String.valueOf(userInfoMap.get("zjlx")) ;
                log.error("zjlxFieldId:"+zjlxFieldId);
                if(StringUtils.isNotBlank(zjlxFieldId)) {
                    Map<String, Object>  optionMap = employeeImportTxtDao.queryFieldOptionByFieldid(Constants.TENANT_KEY,zjlxFieldId);
                    log.error("optionMap:"+optionMap.size());
                    if(optionMap.containsKey(zjlx)){
                        String optionName = String.valueOf(optionMap.get(zjlx));
                        log.error("optionName:"+optionName);
                        userInfoExtend.put(zjlxFieldId,optionName);
                    }
                }
            }

            log.error("jkzk:"+jkzk);
            if(userInfoMap.containsKey("jkzk")){
                String jkzkFieldId = String.valueOf(userInfoMap.get("jkzk")) ;
                log.error("jkzkFieldId:"+jkzkFieldId);
                if(StringUtils.isNotBlank(jkzkFieldId)) {
                    Map<String, Object> optionMap = employeeImportTxtDao.queryFieldOptionByFieldid(Constants.TENANT_KEY,jkzkFieldId);
                    log.error("optionMap:"+optionMap.size());
                    if(optionMap.containsKey(jkzk)){
                        String optionName = String.valueOf(optionMap.get(jkzk));
                        log.error("optionName:"+optionName);
                        userInfoExtend.put(jkzkFieldId,optionName);
                    }
                }
            }

            log.error("mardate:"+mardate);
            if(mardate.length() > 10){
                mardate = mardate.substring(0,10);
            }
            log.error("mardate2:"+mardate);
            if(userInfoMap.containsKey("hysxrq")){
                String hysxrqFieldId = String.valueOf(userInfoMap.get("hysxrq")) ;
                log.error("hysxrqFieldId:"+hysxrqFieldId);
                userInfoExtend.put(hysxrqFieldId,mardate);
            }
            paramJson.put("userInfoExtend",userInfoExtend);

            JSONObject employeeExtend = new JSONObject();
            String employeeFormTable = "ft_1088177870727446575";
            String dataKey2 = "'wbxtgh'";

            log.error("wbxtgh:"+wbxtgh);
            Map<String,Object> employeeExtendMap = employeeImportTxtDao.queryFromTableField(Constants.TENANT_KEY,employeeFormTable,dataKey2);
            if(employeeExtendMap.containsKey("wbxtgh")){
                String wbxtghFieldId = String.valueOf(employeeExtendMap.get("wbxtgh")) ;
                log.error("wbxtghFieldId:"+wbxtghFieldId);
                employeeExtend.put(wbxtghFieldId,wbxtgh);
            }
            paramJson.put("employeeExtend",employeeExtend);

//        paramJson.put("multiObj","");

            if("XFR".equals(action)){
                paramJson.put("id",employeeid);
            }

            /***
             * 数据规则
             */
            JSONObject dataRule = new JSONObject();
            dataRule.put("employee","id");
            dataRule.put("department","id");
            dataRule.put("position","id");

            paramArray.add(paramJson);
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("data",paramArray);
            jsonObject.put("dataRule",dataRule);

            log.error("jsonObject:"+jsonObject.toJSONString());

            try {
                String accessToken = getToken();
                log.error("accessToken:"+accessToken);

                if(StringUtils.isNotBlank(accessToken)){
                    jsonObject.put("access_token",accessToken);

                    OkHttpClient client = new OkHttpClient().newBuilder().build();
                    MediaType mediaType = MediaType.parse("application/json");
                    RequestBody body = RequestBody.create(mediaType, jsonObject.toJSONString());
                    Request request = new Request.Builder()
                            .url(Constants.host+"/papi/openapi/api/hrm/restful/syncEmployee")
                            .method("POST", body)
                            .addHeader("Content-Type", "application/json")
                            .build();

                    Response response = client.newCall(request).execute();
                    int code = response.code();
                    log.error("code:"+code);
                    if (code == 200) {
                        String responseBody = response.body().string();
                        log.error("responseBody:"+responseBody);
                        JSONObject responseObject = JSONObject.parseObject(responseBody);
                        JSONArray dataArray = responseObject.getJSONArray("data");
                        JSONObject dataJson = dataArray.getJSONObject(0);
                        String keyValue = dataJson.getString("keyValue");
                        String operate = dataJson.getString("operate");
                        String status = dataJson.getString("status");
                        String errcode = dataJson.getString("errcode");
                        String needRepush = dataJson.getString("needRepush");
                        returnMap.put("status",status);
                        returnMap.put("operate",operate);
                    }else{
                        returnMap.put("status","fail");
                    }
                }else{
                    returnMap.put("status","fail");
                }
            } catch (IOException e) {
                returnMap.put("status","fail");
                log.error("e:"+e);
            }
        }

        return returnMap;
    }


    @Override
    public Map<String,String> covertEmployeeData(String type) {

        Map<String,String> dataMap = new HashMap<String,String>();
        if("marriage".equals(type)){
            dataMap.put("1","unmarried") ;
            dataMap.put("2","married") ;
        }else if("gender".equals(type)){
            dataMap.put("M","male") ;
            dataMap.put("F","female") ;
        }

//        if("".equals(type)){
//            if("CXDXXL01".equals(dataId)){
//
//            }else if("CXDXXL02".equals(dataId)){
//
//            } else if("CXDXXL03".equals(dataId)){
//
//            }else if("CXDXXL04".equals(dataId)){
//
//            }else if("CXDXXL05".equals(dataId)){
//
//            }else if("CXDXXL06".equals(dataId)){
//
//            }
//        }
//
//        if("".equals(type)){
//            if("0".equals(dataId)){
//
//            }else if("1".equals(dataId)){
//
//            } else if("2".equals(dataId)){
//
//            }else if("3".equals(dataId)){
//
//            }else if("4".equals(dataId)){
//
//            }else if("5".equals(dataId)){
//
//            }
//        }
//
//
//        if("".equals(type)){
//            if("CX100000000023B1".equals(dataId)){
//
//            }else if("CX100000000023B3".equals(dataId)){
//
//            } else if("CX100000000023B5".equals(dataId)){
//
//            }else if("CX100000000023B4".equals(dataId)){
//
//            }else if("CX100000000023JN".equals(dataId)){
//
//            }else if("CX100000000023G7".equals(dataId)){
//
//            }else if("CX100000000023ZX".equals(dataId)){
//
//            }else if("CX100000000023Z2".equals(dataId)){
//
//            }else if("CX100000000023Z1".equals(dataId)){
//
//            }else if("CX100000000023TDJL".equals(dataId)){
//
//            }else if("CX100000000023TDZ".equals(dataId)){
//
//            }else if("CX100000000023XC".equals(dataId)){
//
//            }
//        }
        return dataMap;

    }

    public String getToken(){

        String accessToken = "";
        String tokenCode = getTokeCode();
        log.error("tokenCode:"+tokenCode);

        if(StringUtils.isNotBlank(tokenCode)){
            OkHttpClient client = new OkHttpClient().newBuilder()
                    .build();

//            JSONObject paramJson = new JSONObject();
//            paramJson.put("app_key",Constants.app_key);
//            paramJson.put("app_secret",Constants.app_secret);
//            paramJson.put("grant_type","authorization_code");
//            paramJson.put("code",tokenCode);

            String param = "app_key="+Constants.app_key+"&code="+tokenCode+"&grant_type=authorization_code&app_secret="+Constants.app_secret+"";
            log.error("paramJson:"+param);

            log.error("url:"+Constants.host+"/papi/openapi/oauth2/access_token");


            MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
            RequestBody body = RequestBody.create(mediaType, param);
            Request request = new Request.Builder()
                    .url(Constants.host+"/papi/openapi/oauth2/access_token")
                    .method("POST", body)
                    .addHeader("Content-Type", "application/x-www-form-urlencoded")
                    .build();
            try {
                Response response = client.newCall(request).execute();
                int code = response.code();
                log.error("code:"+code);
                if(code == 200){
                    String responseBody = response.body().string();
                    log.error("responseBody:"+responseBody);
                    if(StringUtils.isNotBlank(responseBody)){
                        JSONObject responseObject = JSONObject.parseObject(responseBody);

                        String errcode = responseObject.getString("errcode");
                        if("0".equals(errcode)){
                            accessToken = responseObject.getString("accessToken");
                        }
                    }
                }
            } catch (IOException e) {
                log.error("e:"+e);
            }
        }

        return accessToken;
    }


    public String getTokeCode(){
        String retrunCode = "";
        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");

        JSONObject paramJson = new JSONObject();

        paramJson.put("corpid",Constants.corpid);
        paramJson.put("response_type","code");
        paramJson.put("state","");

        log.error("paramJson:"+paramJson.toJSONString());
        log.error("url:"+Constants.host+"/papi/openapi/oauth2/authorize");

        RequestBody body = RequestBody.create(mediaType, paramJson.toJSONString());
        Request request = new Request.Builder()
                .url(Constants.host+"/papi/openapi/oauth2/authorize")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .build();
        try {
            Response response = client.newCall(request).execute();
            int code = response.code();
            String dataBody = response.body().string();

            log.error("code:"+code);
            log.error("dataBody:"+dataBody);

            if(code == 200){
                JSONObject bodyObject = JSONObject.parseObject(dataBody);
                String errcode = bodyObject.getString("errcode");
                if("0".equals(errcode)){
                    retrunCode = bodyObject.getString("code");
                }
            }
        } catch (IOException e) {
            log.error(e.getMessage(),e);
            throw new RuntimeException(e);
        }
        return retrunCode;
    }







}
