package com.weaver.seconddev.prod.controller;

import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.prod.constant.Constants;
import com.weaver.seconddev.prod.dao.EmployeeExportTxtDao;
import com.weaver.seconddev.prod.service.EmployeeExportTxtService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/api/secondev/cpicprod/employeeexp")
public class EmployeeExportTxtController {

    private final Logger log = LoggerFactory.getLogger(EmployeeExportTxtController.class);

    @Autowired
    EmployeeExportTxtService employeeExportTxtService;

    @Autowired
    private EmployeeExportTxtDao employeeExportTxtDao;


    @GetMapping("/expTxt1")
    public WeaResult<Object> expTxt1(HttpServletRequest request){
        Map<String, Object> dataMap = new HashMap<String, Object>();
        dataMap.put("test","test");
        return WeaResult.success(dataMap);
    }



    @WeaPermission(publicPermission = true)
    @GetMapping("/expTxt3")
    public ResponseEntity<byte[]> expTxt3(HttpServletRequest request,HttpServletResponse response) {
        log.error("getEmployeeBase");
        String type = request.getParameter("type");
        String employeeExpTxt = employeeExportTxtService.queryEmployeeExpTxt(Constants.TENANT_KEY,type);

        byte[] bytes = employeeExpTxt.getBytes();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String currentDate = sdf.format(new Date());

        String times = employeeExportTxtDao.queryExportTxtTimesByDay(Constants.TENANT_KEY);
        if(StringUtils.isBlank(times)){
            times = "01";
        }
        String filename = "EHR_TO_IMAM_JOB_"+currentDate+times+".txt";
        log.error("filename:"+filename);
        return ResponseEntity.ok().contentType(MediaType.APPLICATION_OCTET_STREAM)
                .header(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + filename + "\"")
                .body(bytes);

    }


    @GetMapping("/expTxt2")
    public WeaResult<Object> expTxt2(HttpServletRequest request){
        Map<String, Object> dataMap = new HashMap<String, Object>();

        List<Map<String, Object>> list1 = employeeExportTxtDao.queryUser(Constants.TENANT_KEY);
        List<Map<String, Object>> list2 = employeeExportTxtDao.queryUserData(Constants.TENANT_KEY);
        dataMap.put("test","test");
        dataMap.put("list1",list1);
        dataMap.put("list2",list2);
        return WeaResult.success(dataMap);
    }



}
