package com.weaver.seconddev.prod.controller;

import com.alibaba.fastjson.JSON;
import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.eteams.file.client.file.FileData;
import com.weaver.file.ud.api.FileDownloadService;
import com.weaver.seconddev.prod.constant.Constants;
import com.weaver.seconddev.prod.dao.EmployeeImportTxtDao;
import com.weaver.seconddev.prod.service.EmployeeImportTxtService;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.*;

@RestController
@RequestMapping("/api/secondev/cpicprod/employeeimp")
public class EmployeeImportTxtController {

    private final Logger log = LoggerFactory.getLogger(EmployeeImportTxtController.class);

    @Autowired
    private FileDownloadService fileDownloadService;

    @Autowired
    EmployeeImportTxtDao employeeImportTxtDao;

    @Autowired
    EmployeeImportTxtService employeeImportTxtService;


    @WeaPermission(publicPermission = true)
    @GetMapping("/imptxt6")
    public WeaResult<Object> imptxt6(HttpServletRequest request, HttpServletResponse response) throws IOException {
        List<Map<String,String>> employeeList = new ArrayList<Map<String,String>>();
        String fileid = request.getParameter("fileid");
        String form_data_id = request.getParameter("form_data_id");
        List<String> lineList = new ArrayList<String>();
        List<String> fieldList = getEmployeeExpFieldList();

        log.error("imptxt6----66666");
        log.error("fieldList:"+fieldList.size());

        if (StringUtils.isNotBlank(fileid)) {
            FileData fileData = fileDownloadService.downloadFile(Long.valueOf(fileid));
            InputStream inputStream = fileData.getInputStream();

            // 使用 BufferedReader 按行读取 InputStream
            try (BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream))) {
                String line;
                while ((line = reader.readLine()) != null) {

                    lineList.add(line);
                }
            }
        }


        Map<String,Map<String,String>> departmentMap = employeeImportTxtDao.getHrmDepartmentCode(Constants.TENANT_KEY);
        Map<String,Object> politicsMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"politicsStatus");
        Map<String,Object> nationMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"nation");
        Map<String,Object> educationMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"education");
        Map<String,Object> householdTypeMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"householdType");
        Map<String,Object> degreeMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"degree");

        Map<String,String> genderMap = employeeImportTxtService.covertEmployeeData("gender");
        Map<String,String> marriageMap = employeeImportTxtService.covertEmployeeData("marriage");

        Map<String,String> nativePaceMap = employeeImportTxtDao.queryPropDataByDl(Constants.TENANT_KEY,"0");

        log.error("politicsMap:"+ JSON.toJSONString(politicsMap));
        log.error("nationMap:"+JSON.toJSONString(nationMap));
        log.error("educationMap:"+JSON.toJSONString(educationMap));
        log.error("householdTypeMap:"+JSON.toJSONString(householdTypeMap));
        log.error("politicsMap:"+JSON.toJSONString(politicsMap));
        log.error("genderMap:"+JSON.toJSONString(genderMap));
        log.error("marriageMap:"+JSON.toJSONString(marriageMap));
        log.error("nativePaceMap:"+JSON.toJSONString(nativePaceMap));
        log.error("degreeMap:"+JSON.toJSONString(degreeMap));


        for(int i = 0 ;i<lineList.size();i++){
            String line = lineList.get(i);
            log.error("line:"+line);
            Map<String,String> employeeMap = new HashMap<String,String>();
            String[] employeeData = line.split("\\|");
            log.error("employeeData:"+employeeData.length);
            for(int k =0 ;k < employeeData.length;k++){
                String value = employeeData[k];
                log.error("value:"+value);
                if(k < fieldList.size()){
                    String key = fieldList.get(k).toUpperCase();
                    employeeMap.put(key,value);
                }
            }

            log.error("employeeMap:"+JSON.toJSONString(employeeMap));

            if(employeeMap.size() > 0){
                employeeList.add(employeeMap);
            }
        }

        int total = employeeList.size();
        int upCount = 0;
        int errCount = 0;
        int inCount = 0;
        for(int i=0;i<employeeList.size();i++){
            Map<String,String> employeeMap = employeeList.get(i);

            // 操作
            String action = employeeMap.get("ACTION");
            String idNo = "";
            String departmentid = "";
            String positionid = "";
            String jobNum = "";

            String personnelStatus = "3";
            String account = "";
            // 姓名
            String userName = employeeMap.get("LAST_NAME")+employeeMap.get("FIRST_NAME");

            // 出生日期
            String birthday = employeeMap.get("BIRTHDATE");
            String maritalStatus = "3";
            String nation = "";
            String gender = "";
            // 婚姻生效日期
            String mardate = employeeMap.get("DATE2");
            String firstWorkDate = "";
            String hireDate = "";
            String nativePlace = "";
            String household_type = "";
            String politicsStatus = "";
            String jkzk = "";
            String mobile = "";
            String zjlx = "";

            String education = "";
            String degree = "";
            String graduate_school = "";
            String graduate_date = "";
            String major = "";

            // 系统工号(外部系统工号)
            String guid = employeeMap.get("GUID");
            //生效日期
            String date1 = employeeMap.get("DATE1");

            // 婚姻状态
            String marStatus = employeeMap.get("MAR_STATUS");
            if(StringUtils.isNotBlank(marStatus)){
                maritalStatus = marriageMap.get(marStatus);
            }

            // 性别
            String sex = employeeMap.get("SEX");
            if(StringUtils.isNotBlank(sex)){
                gender = genderMap.get(sex);
            }

            //身份证
            String nationalId = employeeMap.get("NATIONAL_ID");
            if(StringUtils.isNotBlank(nationalId)){
                idNo = nationalId;
                jobNum = nationalId;
            }

            // 民族
            String ethnicGrpCd = employeeMap.get("ETHNIC_GRP_CD");
            if(StringUtils.isNotBlank(ethnicGrpCd)){
                if(nationMap.containsKey(ethnicGrpCd)){
                    nation = String.valueOf(nationMap.get(ethnicGrpCd));
                }
            }

            // 开始工作日期
            String startDtChn = employeeMap.get("START_DT_CHN");
            if(StringUtils.isNotBlank(startDtChn)){
                firstWorkDate = startDtChn ;
            }

            // 岗位部门
            String positionNbr = employeeMap.get("POSITION_NBR");
            if(StringUtils.isNotBlank(positionNbr)){
                if(departmentMap.containsKey(positionNbr)){
                    Map<String,String> postMap = departmentMap.get(positionNbr);
                    departmentid = String.valueOf(postMap.get("departmentid"));
                    positionid = String.valueOf(postMap.get("positionid"));
                }
            }

            // 入司日期
            String dcCoEntryDt = employeeMap.get("DC_CO_ENTRY_DT");
            if(StringUtils.isNotBlank(dcCoEntryDt)){
                hireDate = dcCoEntryDt;
            }

            // 籍贯
            String nativePlaceChn = employeeMap.get("NATIVE_PLACE_CHN");
            if(StringUtils.isNotBlank(nativePlaceChn)){
                if(nativePaceMap.containsKey(nativePlaceChn)){
                    nativePlace = String.valueOf(nativePaceMap.get(nativePlaceChn)) ;
                }
            }

            // 户籍性质
            String hukouTypeChn = employeeMap.get("HUKOU_TYPE_CHN");
            if(StringUtils.isNotBlank(hukouTypeChn)){
                if(householdTypeMap.containsKey(hukouTypeChn)){
                    household_type = String.valueOf(householdTypeMap.get(hukouTypeChn));
                }
            }

            // 政治面貌
            String politicalStaChn = employeeMap.get("POLITICAL_STA_CHN");
            if(StringUtils.isNotBlank(politicalStaChn)){
                if(politicsMap.containsKey(politicalStaChn)){
                    politicsStatus = String.valueOf(politicsMap.get(politicalStaChn));
                }
            }

            // 健康状况
            String dcHealthStatus = employeeMap.get("DC_HEALTH_STATUS");
            if(StringUtils.isNotBlank(dcHealthStatus)){
                jkzk  = dcHealthStatus ;
            }


            // 电话
            String phone = employeeMap.get("PHONE");
            if(StringUtils.isNotBlank(phone)){
                mobile = phone ;
                account = phone ;
            }

            // 证件类型
            String nationalIdType = employeeMap.get("NATIONAL_ID_TYPE");
            if(StringUtils.isNotBlank(nationalIdType)){
                zjlx = nationalIdType;
            }

            //学历
            String dcEducation = employeeMap.get("DC_EDUCATION");
            if(StringUtils.isNotBlank(dcEducation)){
                if(educationMap.containsKey(dcEducation)){
                    education = String.valueOf(educationMap.get(dcEducation));
                }
            }

            // 全日制最高学位
            String dcDegree = employeeMap.get("DC_DEGREE");
            if(StringUtils.isNotBlank(dcDegree)){
                if(degreeMap.containsKey(dcDegree)){
                    degree = String.valueOf(degreeMap.get(dcDegree));
                }
            }

            // 学校
            String dcSchool = employeeMap.get("DC_SCHOOL");
            if(StringUtils.isNotBlank(dcSchool)){
                graduate_school = dcSchool ;
            }

            // 开始结束日期
            String dcStartDt = employeeMap.get("DC_START_DT");
            if(StringUtils.isNotBlank(dcStartDt)){
                graduate_date = dcStartDt;
            }

            // 专业
            String dcMajor = employeeMap.get("DC_MAJOR");
            if(StringUtils.isNotBlank(major)){
                major = dcMajor ;
            }

            log.error("action:"+action);
            log.error("userName:"+userName);
            log.error("departmentid:"+departmentid);
            log.error("idNo:"+idNo);
            log.error("birthday:"+birthday);
            log.error("positionid:"+positionid);
            log.error("maritalStatus:"+maritalStatus);
            log.error("nation:"+nation);
            log.error("action:"+action);
            log.error("personnelStatus:"+personnelStatus);
            log.error("account:"+account);
            log.error("firstWorkDate:"+firstWorkDate);

            log.error("mobile:"+mobile);
            log.error("gender:"+gender);
            log.error("hireDate:"+hireDate);
            log.error("nativePlace:"+nativePlace);
            log.error("household_type:"+household_type);
            log.error("politicsStatus:"+politicsStatus);
            log.error("jobNum:"+jobNum);

            if(StringUtils.isNotBlank(action) && StringUtils.isNotBlank(departmentid) && StringUtils.isNotBlank(idNo)){
                Map<String,String> codeMap = employeeImportTxtService.syncEmployeeData(action,userName,departmentid,idNo,
                        birthday,positionid,maritalStatus,nation,
                        personnelStatus,
                        account,firstWorkDate,
                        mobile,gender,hireDate,idNo,
                        nativePlace,household_type,politicsStatus,
                        jobNum, graduate_date,graduate_school,degree,education,
                        mardate,zjlx,major,jkzk
                );

                String status = codeMap.get("status");
                if("SUCCESS".equals(status)){
                    String operate = codeMap.get("operate");
                    if("UPDATE".equals(operate)){
                        upCount++;
                    }else{
                        inCount++;
                    }
                }else{
                    errCount++;
                }
            }
        }

        if(StringUtils.isNotBlank(form_data_id)){
            employeeImportTxtDao.updateEmployeeImpResult(Constants.TENANT_KEY,form_data_id,String.valueOf(total),String.valueOf(inCount),String.valueOf(upCount),String.valueOf(errCount));
        }

        Map<String, Object> recordMap = new HashMap<String,Object>();
        recordMap.put("upCount",upCount);
        recordMap.put("inCount",inCount);
        recordMap.put("total",total);
        return WeaResult.success(recordMap);
    }



    public List<String> getEmployeeExpFieldList() {

        List<String> fieldList = new ArrayList<String>();
        /**
         * 系统工号(外部系统工号)
         */
        fieldList.add("GUID");
        fieldList.add("DATE1");
        /**
         * 出生日期
         */
        fieldList.add("BIRTHDATE");
        /**
         * 姓
         * 名
         */
        fieldList.add("LAST_NAME");
        fieldList.add("FIRST_NAME");

        fieldList.add("DATE2");

        /**
         * 婚姻状态
         */
        fieldList.add("MAR_STATUS");



        /**
         * 性别
         */
        fieldList.add("SEX");
        /**
         * 证件号（根据证件号匹配）
         */
        fieldList.add("NATIONAL_ID");
        /***
         * 民族
         */
        fieldList.add("ETHNIC_GRP_CD");

        fieldList.add("DATE3");

        /***
         * 开始工作日期
         */
        fieldList.add("START_DT_CHN");
        /**
         * 操作
         */
        fieldList.add("ACTION");
        /***
         * 岗位部门
         */
        fieldList.add("POSITION_NBR");
        /***
         * 入司日期
         */
        fieldList.add("DC_CO_ENTRY_DT");
        /**
         * 首次入太保日期
         */
        fieldList.add("DC_CPIC_ENTRY_DT");
        /**
         * 最近入太保日期
         */
        fieldList.add("DC_LAST_ENTRY_DT");
        /**
         * 籍贯
         */
        fieldList.add("NATIVE_PLACE_CHN");
        /**
         * 户籍性质
         */
        fieldList.add("HUKOU_TYPE_CHN");
        /**
         * 政治面貌
         */
        fieldList.add("POLITICAL_STA_CHN");
        /***
         * 健康状况
         */
        fieldList.add("DC_HEALTH_STATUS");
        /***
         * 电话
         */
        fieldList.add("PHONE");
        /***
         * 证件类型
         */
        fieldList.add("NATIONAL_ID_TYPE");
        /**
         * 全日制最高学历
         */
        fieldList.add("DC_EDUCATION");
        /***
         * 全日制最高学位
         */
        fieldList.add("DC_DEGREE");
        /**
         * 学校
         */
        fieldList.add("DC_SCHOOL");

        /***
         * 开始结束日期
         */
        fieldList.add("DC_START_DT");

        /**
         * 专业
         */
        fieldList.add("DC_MAJOR");

        return fieldList;
    }


    @GetMapping("/imptxt1")
    public WeaResult<Object> imptxt1(HttpServletRequest request){
        log.error("getWorkData");
        Map<String, Object> dataMap = new HashMap<String, Object>();
        dataMap.put("test","test");
        return WeaResult.success(dataMap);
    }


    @GetMapping("/imptxt2")
    public WeaResult<Object> imptxt2(HttpServletRequest request,HttpServletResponse response){
        log.error("getWorkData");
        Map<String, Object> dataMap = new HashMap<String, Object>();
        String idno = request.getParameter("idno");
        String employeeid = employeeImportTxtDao.queryHrmUserByNationalId(Constants.TENANT_KEY,idno);

        dataMap.put("employeeid",employeeid);
        return WeaResult.success(dataMap);
    }


}
