package com.weaver.seconddev.prod.esb.action;

import com.alibaba.fastjson.JSON;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.eteams.file.client.file.FileData;
import com.weaver.file.ud.api.FileDownloadService;
import com.weaver.seconddev.prod.constant.Constants;
import com.weaver.seconddev.prod.dao.EmployeeImportTxtDao;
import com.weaver.seconddev.prod.service.EmployeeImportTxtService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service("Cpic_Prod_EmployeeImportTxtAction")
public class EmployeeImportTxtAction implements EsbServerlessRpcRemoteInterface {

    private final static Logger log = LoggerFactory.getLogger(EmployeeImportTxtAction.class);

    @Autowired
    private FileDownloadService fileDownloadService;

    @Autowired
    EmployeeImportTxtDao employeeImportTxtDao;

    @Autowired
    EmployeeImportTxtService employeeImportTxtService;

    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> params) {

        List<Map<String,String>> employeeList = new ArrayList<Map<String,String>>();

        String form_data_id = String.valueOf(params.get("form_data_id"));
        List<String> lineList = new ArrayList<String>();
        log.error("CreatePerformanceWorkflowAction:form_data_id:"+form_data_id);
        try{
            List<String> fieldList = getEmployeeExpFieldList();

            Map<String,Object> mainData = employeeImportTxtDao.queryMainDataByFormDataId(Constants.TENANT_KEY,form_data_id);
            String drwj = String.valueOf(mainData.get("drwj"));

            if (StringUtils.isNotBlank(drwj)) {
                FileData fileData = fileDownloadService.downloadFile(Long.valueOf(drwj));
                InputStream inputStream = fileData.getInputStream();
                try (BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream))) {
                    String line;
                    while ((line = reader.readLine()) != null) {
                        lineList.add(line);
                    }
                }
            }

            Map<String,Map<String,String>> departmentMap = employeeImportTxtDao.getHrmDepartmentCode(Constants.TENANT_KEY);
            Map<String,Object> politicsMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"politicsStatus");
            Map<String,Object> nationMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"nation");
            Map<String,Object> educationMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"education");
            Map<String,Object> householdTypeMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"householdType");
            Map<String,Object> degreeMap = employeeImportTxtDao.getHrDictionarySetting(Constants.TENANT_KEY,"degree");

            Map<String,String> genderMap = employeeImportTxtService.covertEmployeeData("gender");
            Map<String,String> marriageMap = employeeImportTxtService.covertEmployeeData("marriage");

            Map<String,String> nativePaceMap = employeeImportTxtDao.queryPropDataByDl(Constants.TENANT_KEY,"0");

            log.error("politicsMap:"+ JSON.toJSONString(politicsMap));
            log.error("nationMap:"+JSON.toJSONString(nationMap));
            log.error("educationMap:"+JSON.toJSONString(educationMap));
            log.error("householdTypeMap:"+JSON.toJSONString(householdTypeMap));
            log.error("politicsMap:"+JSON.toJSONString(politicsMap));
            log.error("genderMap:"+JSON.toJSONString(genderMap));
            log.error("marriageMap:"+JSON.toJSONString(marriageMap));
            log.error("nativePaceMap:"+JSON.toJSONString(nativePaceMap));
            log.error("degreeMap:"+JSON.toJSONString(degreeMap));


            for(int i = 0 ;i<lineList.size();i++){
                String line = lineList.get(i);
                log.error("line:"+line);
                Map<String,String> employeeMap = new HashMap<String,String>();
                String[] employeeData = line.split("\\|");
                log.error("employeeData:"+employeeData.length);
                for(int k =0 ;k < employeeData.length;k++){
                    String value = employeeData[k];
                    log.error("value:"+value);
                    if(k < fieldList.size()){
                        String key = fieldList.get(k).toUpperCase();
                        employeeMap.put(key,value);
                    }
                }

                log.error("employeeMap:"+JSON.toJSONString(employeeMap));

                if(employeeMap.size() > 0){
                    employeeList.add(employeeMap);
                }
            }

            int total = employeeList.size();
            int upCount = 0;
            int errCount = 0;
            int inCount = 0;
            for(int i=0;i<employeeList.size();i++){
                Map<String,String> employeeMap = employeeList.get(i);
                String action = employeeMap.get("ACTION");
                String idNo = "";
                String departmentid = "";
                String positionid = "";
                String jobNum = "";

                String personnelStatus = "3";
                String account = "";
                String userName = employeeMap.get("LAST_NAME")+employeeMap.get("FIRST_NAME");
                String birthday = employeeMap.get("BIRTHDATE");
                String maritalStatus = "3";
                String nation = "";
                String gender = "";
                String mardate = employeeMap.get("DATE2");
                String firstWorkDate = "";
                String hireDate = "";
                String nativePlace = "";
                String household_type = "";
                String politicsStatus = "";
                String jkzk = "";
                String mobile = "";
                String zjlx = "";

                String education = "";
                String degree = "";
                String graduate_school = "";
                String graduate_date = "";
                String major = "";


                String marStatus = employeeMap.get("MAR_STATUS");
                if(StringUtils.isNotBlank(marStatus)){
                    maritalStatus = marriageMap.get(marStatus);
                }

                String sex = employeeMap.get("SEX");
                if(StringUtils.isNotBlank(sex)){
                    gender = genderMap.get(sex);
                }

                //身份证
                String nationalId = employeeMap.get("NATIONAL_ID");
                if(StringUtils.isNotBlank(nationalId)){
                    idNo = nationalId;
                    jobNum = nationalId;
                }

                String ethnicGrpCd = employeeMap.get("ETHNIC_GRP_CD");
                if(StringUtils.isNotBlank(ethnicGrpCd)){
                    if(nationMap.containsKey(ethnicGrpCd)){
                        nation = String.valueOf(nationMap.get(ethnicGrpCd));
                    }
                }

                String startDtChn = employeeMap.get("START_DT_CHN");
                if(StringUtils.isNotBlank(startDtChn)){
                    firstWorkDate = startDtChn ;
                }

                String positionNbr = employeeMap.get("POSITION_NBR");
                if(StringUtils.isNotBlank(positionNbr)){
                    if(departmentMap.containsKey(positionNbr)){
                        Map<String,String> postMap = departmentMap.get(positionNbr);
                        departmentid = String.valueOf(postMap.get("departmentid"));
                        positionid = String.valueOf(postMap.get("positionid"));
                    }
                }

                String dcCoEntryDt = employeeMap.get("DC_CO_ENTRY_DT");
                if(StringUtils.isNotBlank(dcCoEntryDt)){
                    hireDate = dcCoEntryDt;
                }


                String nativePlaceChn = employeeMap.get("NATIVE_PLACE_CHN");
                if(StringUtils.isNotBlank(nativePlaceChn)){
                    if(nativePaceMap.containsKey(nativePlaceChn)){
                        nativePlace = String.valueOf(nativePaceMap.get(nativePlaceChn)) ;
                    }
                }

                String hukouTypeChn = employeeMap.get("HUKOU_TYPE_CHN");
                if(StringUtils.isNotBlank(hukouTypeChn)){
                    if(householdTypeMap.containsKey(hukouTypeChn)){
                        household_type = String.valueOf(householdTypeMap.get(hukouTypeChn));
                    }
                }

                String politicalStaChn = employeeMap.get("POLITICAL_STA_CHN");
                if(StringUtils.isNotBlank(politicalStaChn)){
                    if(politicsMap.containsKey("politicalStaChn")){
                        politicsStatus = String.valueOf(politicsMap.get("politicsMap"));
                    }
                }

                String dcHealthStatus = employeeMap.get("DC_HEALTH_STATUS");
                if(StringUtils.isNotBlank(dcHealthStatus)){
                    jkzk  = dcHealthStatus ;
                }


                String phone = employeeMap.get("PHONE");
                if(StringUtils.isNotBlank(phone)){
                    mobile = phone ;
                    account = phone ;
                }

                String nationalIdType = employeeMap.get("NATIONAL_ID_TYPE");
                if(StringUtils.isNotBlank(nationalIdType)){
                    zjlx = nationalIdType;
                }

                //学历
                String dcEducation = employeeMap.get("DC_EDUCATION");
                if(StringUtils.isNotBlank(dcEducation)){
                    if(educationMap.containsKey(dcEducation)){
                        education = String.valueOf(educationMap.get(dcEducation));
                    }
                }
                String dcDegree = employeeMap.get("DC_DEGREE");
                if(StringUtils.isNotBlank(dcDegree)){
                    if(degreeMap.containsKey(dcDegree)){
                        degree = String.valueOf(degreeMap.get(dcDegree));
                    }
                }
                String dcSchool = employeeMap.get("DC_SCHOOL");
                if(StringUtils.isNotBlank(dcSchool)){
                    graduate_school = dcSchool ;
                }
                String dcStartDt = employeeMap.get("DC_START_DT");
                if(StringUtils.isNotBlank(dcStartDt)){
                    graduate_date = dcStartDt;
                }

                String dcMajor = employeeMap.get("DC_MAJOR");
                if(StringUtils.isNotBlank(major)){
                    major = dcMajor ;
                }

                log.error("action:"+action);
                log.error("userName:"+userName);
                log.error("departmentid:"+departmentid);
                log.error("idNo:"+idNo);
                log.error("birthday:"+birthday);
                log.error("positionid:"+positionid);
                log.error("maritalStatus:"+maritalStatus);
                log.error("nation:"+nation);
                log.error("action:"+action);
                log.error("personnelStatus:"+personnelStatus);
                log.error("account:"+account);
                log.error("firstWorkDate:"+firstWorkDate);

                log.error("mobile:"+mobile);
                log.error("gender:"+gender);
                log.error("hireDate:"+hireDate);
                log.error("nativePlace:"+nativePlace);
                log.error("household_type:"+household_type);
                log.error("politicsStatus:"+politicsStatus);
                log.error("jobNum:"+jobNum);


                if(StringUtils.isNotBlank(action) && StringUtils.isNotBlank(departmentid) && StringUtils.isNotBlank(idNo)){
                    Map<String,String> codeMap = employeeImportTxtService.syncEmployeeData(action,userName,departmentid,idNo,
                            birthday,positionid,maritalStatus,nation,
                            personnelStatus,
                            account,firstWorkDate,
                            mobile,gender,hireDate,idNo,
                            nativePlace,household_type,politicsStatus,
                            jobNum, graduate_date,graduate_school,degree,education,
                            mardate,zjlx,major,jkzk

                    );

                    log.error("codeMap:"+JSON.toJSONString(codeMap));

                    String status = codeMap.get("status");
                    if("SUCCESS".equalsIgnoreCase(status)){
                        String operate = codeMap.get("operate");
                        if("UPDATE".equalsIgnoreCase(operate)){
                            upCount++;
                        }else{
                            inCount++;
                        }
                    }else{
                        errCount++;
                    }
                }
            }

            log.error("upCount:"+upCount);
            log.error("inCount:"+inCount);
            log.error("errCount:"+errCount);

//            Map<String, Object> recordMap = new HashMap<String,Object>();
//            recordMap.put("upCount",upCount);
//            recordMap.put("inCount",inCount);
//            recordMap.put("total",total);

            employeeImportTxtDao.updateEmployeeImpResult(Constants.TENANT_KEY,form_data_id,String.valueOf(total),String.valueOf(inCount),String.valueOf(upCount),String.valueOf(errCount));

        }catch (Exception e){
            return WeaResult.fail(500,"创建子流程异常");
        }

        Map<String, Object> actionMap = new HashMap<>();
        actionMap.put("code",200);
        actionMap.put("msg","创建流程成功");
        return WeaResult.success(actionMap);
    }

    /***
     *
     * @return
     */
    public List<String> getEmployeeExpFieldList() {

        List<String> fieldList = new ArrayList<String>();
        /**
         * 系统工号(外部系统工号)
         */
        fieldList.add("GUID");
        fieldList.add("DATE1");
        /**
         * 出生日期
         */
        fieldList.add("BIRTHDATE");
        /**
         * 姓
         * 名
         */
        fieldList.add("LAST_NAME");
        fieldList.add("FIRST_NAME");

        fieldList.add("DATE2");

        /**
         * 婚姻状态
         */
        fieldList.add("MAR_STATUS");



        /**
         * 性别
         */
        fieldList.add("SEX");
        /**
         * 证件号（根据证件号匹配）
         */
        fieldList.add("NATIONAL_ID");
        /***
         * 民族
         */
        fieldList.add("ETHNIC_GRP_CD");

        fieldList.add("DATE3");

        /***
         * 开始工作日期
         */
        fieldList.add("START_DT_CHN");
        /**
         * 操作
         */
        fieldList.add("ACTION");
        /***
         * 岗位部门
         */
        fieldList.add("POSITION_NBR");
        /***
         * 入司日期
         */
        fieldList.add("DC_CO_ENTRY_DT");
        /**
         * 首次入太保日期
         */
        fieldList.add("DC_CPIC_ENTRY_DT");
        /**
         * 最近入太保日期
         */
        fieldList.add("DC_LAST_ENTRY_DT");
        /**
         * 籍贯
         */
        fieldList.add("NATIVE_PLACE_CHN");
        /**
         * 户籍性质
         */
        fieldList.add("HUKOU_TYPE_CHN");
        /**
         * 政治面貌
         */
        fieldList.add("POLITICAL_STA_CHN");
        /***
         * 健康状况
         */
        fieldList.add("DC_HEALTH_STATUS");
        /***
         * 电话
         */
        fieldList.add("PHONE");
        /***
         * 证件类型
         */
        fieldList.add("NATIONAL_ID_TYPE");
        /**
         * 全日制最高学历
         */
        fieldList.add("DC_EDUCATION");
        /***
         * 全日制最高学位
         */
        fieldList.add("DC_DEGREE");
        /**
         * 学校
         */
        fieldList.add("DC_SCHOOL");

        /***
         * 开始结束日期
         */
        fieldList.add("DC_START_DT");

        /**
         * 专业
         */
        fieldList.add("DC_MAJOR");

        return fieldList;
    }
}
